
/****************************************************************************
 * This file is part of the program  PhyloQFold 			                *
 * for MCMC-sampling consensus secondary structures with pseudoknot         *
 * for a given alignment of RNA sequences and a given phylogeny.            *                                       
 *                                                                          *
 *    Copyright (C) 2012  Dirk Metzler & Gero Doose                        *
 *    e-mail: metzler@bio.lmu.de and gero.doose@gmx.de                      *
 *                                                                          *
 *  This program is free software; you can redistribute it and/or modify    *
 *  it under the terms of the GNU General Public License as published by    *
 *  the Free Software Foundation; either version 2 of the License, or       *
 *  (at your option) any later version.                                     *
 *                                                                          *
 *  This program is distributed in the hope that it will be useful,         *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 *  GNU General Public License for more details.                            *
 *                                                                          *
 *  You should have received a copy of the GNU General Public License       *
 *  along with this program; if not, write to the                           *
 *  Free Software Foundation, Inc., 59 Temple Place, Suite 330,             *
 *  Boston, MA  02111-1307  USA                                             *
 ****************************************************************************/


#ifndef PHYLOGENY_H_
#define PHYLOGENY_H_
#include <iostream>
#include <fstream>
#include <cmath>
#include <cstdlib>
#include <iostream>
#include <cstring>
#include <iostream>
#include <sstream>
#include <vector>
#include <string>
#include "Node.h"
class Phylogeny {
private:
	Node * const buildTree (string & newick, Node * const & parent, int from, int to, vector <string> const & seqIds);
	void loadAlignment(vector <string> * const  & pAlignment,vector <string> & seqIds );
	void loadAlignment(vector <string> * const  & alignmentForColProb,
			vector <string> & seqIds, unsigned int n);
	char intToChar(int const a);
public:
	string loadtree();
	Node * const parseNewick(string s,vector <string> const & seqIds);
	Phylogeny(vector<string>* const & pAlignment, vector<string> & seqIds);

	//uberladener constructor fuer simulationsstudie  n ist die anzahlder sequencen in dem zu simulierenden alignment
	//Phylogeny(vector<string>* const & alignmentForColProb,
	//		vector<string> & seqIds,unsigned int n);
	virtual ~Phylogeny();
};

#endif /* PHYLOGENY_H_ */
